Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# CollisionTraverser Class Reference

This class manages the traversal through the scene graph to detect collisions. More...

Inheritance diagram for CollisionTraverser:

List of all members.

## Public Member Functions
| CollisionTraverser (string name)
| CollisionTraverser ()
| addCollider (NodePath const collider, CollisionHandler handler)
| Adds a new CollisionNode, representing an object that will be tested for collisions into other objects, along with the handler that will serve each detected collision.
| clearColliders ()
| Completely empties the set of collision nodes and their associated handlers.
| clearRecorder ()
| Removes the CollisionRecorder from the traverser and restores normal low-overhead operation.
NodePath | getCollider (int n)
| Returns the nth CollisionNode that has been added to the traverser via add_collider().
list | getColliders ()
CollisionHandler | getHandler (NodePath const collider)
| Returns the handler that is currently assigned to serve the indicated collision node, or NULL if the node is not on the traverser's set of active nodes.
int | getNumColliders ()
| Returns the number of CollisionNodes that have been added to the traverser via add_collider().
CollisionRecorder | getRecorder ()
| Returns the CollisionRecorder currently assigned, or NULL if no recorder is assigned.
bool | getRespectPrevTransform ()
| Returns the flag that indicates whether the prev_transform stored on a node is respected to calculate collisions.
bool | hasCollider (NodePath const collider)
| Returns true if the indicated node is current in the set of nodes that will be tested each frame for collisions into other objects.
bool | hasRecorder ()
| Returns true if the CollisionTraverser has a CollisionRecorder object currently assigned, false otherwise.
| hideCollisions ()
| Undoes the effect of a previous call to show_collisions().
| output (ostream out)
| Outputs the Namable.
bool | removeCollider (NodePath const collider)
| Removes the collider (and its associated handler) from the set of CollisionNodes that will be tested each frame for collisions into other objects.
| setRecorder (CollisionRecorder recorder)
| Uses the indicated CollisionRecorder object to start recording the intersection tests made by each subsequent call to traverse() on this object.
| setRespectPrevTransform (bool flag)
| Sets the flag that indicates whether the prev_transform stored on a node (as updated via set_fluid_pos(), etc.) is respected to calculate collisions.
CollisionVisualizer | showCollisions (NodePath const root)
| This is a high-level function to create a CollisionVisualizer object to render the collision tests performed by this traverser.
| traverse (NodePath const root)
| write (ostream out, int indent_level)
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

This class manages the traversal through the scene graph to detect collisions.

It holds ownership of a number of collider objects, each of which is a CollisionNode and an associated CollisionHandler.

When traverse() is called, it begins at the indicated root and detects all collisions with any of its collider objects against nodes at or below the indicated root, calling the appropriate CollisionHandler for each detected collision.

## Constructor & Destructor Documentation

CollisionTraverser | ( | string | name | ) |

CollisionTraverser | ( |  | ) |

## Member Function Documentation

addCollider | ( | NodePath const | collider,
|  | CollisionHandler | handler
| ) |  |

Adds a new CollisionNode, representing an object that will be tested for collisions into other objects, along with the handler that will serve each detected collision.

Each CollisionNode may be served by only one handler at a time, but a given handler may serve many CollisionNodes.

The handler that serves a particular node may be changed from time to time by calling add_collider() again on the same node.

clearColliders | ( |  | ) |

Completely empties the set of collision nodes and their associated handlers.

clearRecorder | ( |  | ) |

Removes the CollisionRecorder from the traverser and restores normal low-overhead operation.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from Namable.

NodePath getCollider | ( | int | n | ) |

Returns the nth CollisionNode that has been added to the traverser via add_collider().

list getColliders | ( |  | ) |

CollisionHandler getHandler | ( | NodePath const | collider | ) |

Returns the handler that is currently assigned to serve the indicated collision node, or NULL if the node is not on the traverser's set of active nodes.

int getNumColliders | ( |  | ) |

Returns the number of CollisionNodes that have been added to the traverser via add_collider().

CollisionRecorder getRecorder | ( |  | ) |

Returns the CollisionRecorder currently assigned, or NULL if no recorder is assigned.

bool getRespectPrevTransform | ( |  | ) |

Returns the flag that indicates whether the prev_transform stored on a node is respected to calculate collisions.

See set_respect_prev_transform().

bool hasCollider | ( | NodePath const | collider | ) |

Returns true if the indicated node is current in the set of nodes that will be tested each frame for collisions into other objects.

bool hasRecorder | ( |  | ) |

Returns true if the CollisionTraverser has a CollisionRecorder object currently assigned, false otherwise.

hideCollisions | ( |  | ) |

Undoes the effect of a previous call to show_collisions().

output | ( | ostream | out | ) |

Outputs the Namable.

This function simply writes the name to the output stream; most Namable derivatives will probably redefine this.

Reimplemented from Namable.

bool removeCollider | ( | NodePath const | collider | ) |

Removes the collider (and its associated handler) from the set of CollisionNodes that will be tested each frame for collisions into other objects.

Returns true if the definition was found and removed, false if it wasn't present to begin with.

setRecorder | ( | CollisionRecorder | recorder | ) |

Uses the indicated CollisionRecorder object to start recording the intersection tests made by each subsequent call to traverse() on this object.

A particular CollisionRecorder object can only record one traverser at a time; if this object has already been assigned to another traverser, that assignment is broken.

This is intended to be used in a debugging mode to try to determine what work is being performed by the collision traversal. Usually, attaching a recorder will impose significant runtime overhead.

This does not transfer ownership of the CollisionRecorder pointer; maintenance of that remains the caller's responsibility. If the CollisionRecorder is destructed, it will cleanly remove itself from the traverser.

setRespectPrevTransform | ( | bool | flag | ) |

Sets the flag that indicates whether the prev_transform stored on a node (as updated via set_fluid_pos(), etc.) is respected to calculate collisions.

If this is true, certain types of collision tests will be enhanced by the information about objects in motion. If this is false, objects are always considered to be static. The default is false.

CollisionVisualizer showCollisions | ( | NodePath const | root | ) |

This is a high-level function to create a CollisionVisualizer object to render the collision tests performed by this traverser.

The supplied root should be any node in the scene graph; typically, the top node (e.g. render). The CollisionVisualizer will be attached to this node.

traverse | ( | NodePath const | root | ) |

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties